<template>
  <div class="row items-baseline">
    <q-select
      :label="t('typeOfInsurance')"
      v-model="selectedInsuranceType"
      :options="possibleInsuranceTypeOptions"
      map-options
      class="q-mb-md col-10"
      emit-value
      dense
      dropdown-icon="expand_more"
      outlined
    />
    <q-select
      :label="t('package')"
      v-model="selectedPackage"
      :options="possibleCurrentPackageOptions"
      map-options
      class="q-mb-md col-10"
      emit-value
      dense
      dropdown-icon="expand_more"
      outlined
    />
  </div>
  <div class="row items-baseline">
    <q-input
      dense
      outlined
      type="number"
      min="1"
      class="q-mb-md col-10"
      max="3"
      v-model="countOfPeople"
      :label="t('numberOfPeople')"
    />
    <q-icon class="q-ml-md" name="info" size="large" color="primary">
      <q-tooltip>{{ t('maximumPeople') }}</q-tooltip>
    </q-icon>
  </div>
</template>
<script setup lang="ts">
import { useI18n } from 'vue-i18n';
import {
  defineEmits,
  defineProps,
  withDefaults,
  computed,
  watch,
  ref,
} from 'vue';
import { config } from 'src/utils/insurence-contansts';
const { t } = useI18n();

type Props = {
  selectedPackage: number | null;
  selectedInsuranceType: string | null;
  countOfPeople: number | string;
};
interface Emits {
  (e: 'update:selectedInsuranceType', value: string): void;
  (e: 'update:selectedPackage', value: string): void;
  (e: 'update:countOfPeople', value: number): void;
}

const props = withDefaults(defineProps<Props>(), {
  selectedPackage: null,
  selectedInsuranceType: null,
  countOfPeople: 1,
});

const emit = defineEmits<Emits>();

const selectedPackage = computed({
  get() {
    return props.selectedPackage;
  },
  set(newPackage: selectedPackage) {
    emit('update:selectedPackage', newPackage);
  },
});

const selectedInsuranceType = computed({
  get() {
    return props.selectedInsuranceType;
  },
  set(newSelectedInsuranceType: newSelectedInsuranceType) {
    emit('update:selectedInsuranceType', newSelectedInsuranceType);
  },
});
const countOfPeople = computed({
  get() {
    return props.countOfPeople;
  },
  set(countOfPeople: countOfPeople) {
    emit('update:countOfPeople', countOfPeople);
  },
});

const possibleLongPeriodPackageOptions = computed(() => [
  {
    label: t('optionInsurance.basics'),
    value: config.longTimePeriod.basics,
  },
  {
    label: t('optionInsurance.extended'),
    value: config.longTimePeriod.extended,
  },
  {
    label: t('optionInsurance.extra'),
    value: config.longTimePeriod.extra,
  },
]);
const possibleShortPeriodPackageOptions = computed(() => [
  {
    label: t('optionInsurance.basics'),
    value: config.shortTimePeriod.basics,
  },
  {
    label: t('optionInsurance.extended'),
    value: config.shortTimePeriod.extended,
  },
  {
    label: t('optionInsurance.extra'),
    value: config.shortTimePeriod.extra,
  },
]);
const possibleCurrentPackageOptions = computed(() => {
  if (
    selectedInsuranceType.value === t('possibleInsuranceTypeOptions.shortTime')
  ) {
    return possibleShortPeriodPackageOptions.value;
  }
  return possibleLongPeriodPackageOptions.value;
});

const possibleInsuranceTypeOptions = computed(() => [
  t('possibleInsuranceTypeOptions.shortTime'),
  t('possibleInsuranceTypeOptions.longTime'),
]);

const resetValues = () => {
  selectedPackage.value = null;
  countOfPeople.value = 1;
};

watch(selectedInsuranceType, (newTypeOfInsurence, oldnewTypeOfInsurence) => {
  if (newTypeOfInsurence !== oldnewTypeOfInsurence) {
    resetValues();
  }
});
watch(countOfPeople, (newVal) => {
  if (newVal <= 3) {
    countOfPeople.value = newVal;
  } else countOfPeople.value = 3;
});
</script>
